"use strict";
/**
 * (C) Copyright IBM Corp. 2022.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
/**
 * IBM OpenAPI SDK Code Generator Version: 3.45.1-632ec580-20220210-190638
 */
var extend = require("extend");
var ibm_cloud_sdk_core_1 = require("ibm-cloud-sdk-core");
var common_1 = require("../lib/common");
/**
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * API Version: 1.0
 */
var EventNotificationsV1 = /** @class */ (function (_super) {
    __extends(EventNotificationsV1, _super);
    /**
     * Construct a EventNotificationsV1 object.
     *
     * @param {Object} options - Options for the service.
     * @param {string} [options.serviceUrl] - The base url to use when contacting the service. The base url may differ between IBM Cloud regions.
     * @param {OutgoingHttpHeaders} [options.headers] - Default headers that shall be included with every request to the service.
     * @param {Authenticator} options.authenticator - The Authenticator object used to authenticate requests to the service
     * @constructor
     * @returns {EventNotificationsV1}
     */
    function EventNotificationsV1(options) {
        var _this = this;
        options = options || {};
        _this = _super.call(this, options) || this;
        if (options.serviceUrl) {
            _this.setServiceUrl(options.serviceUrl);
        }
        else {
            _this.setServiceUrl(EventNotificationsV1.DEFAULT_SERVICE_URL);
        }
        return _this;
    }
    /*************************
     * Factory method
     ************************/
    /**
     * Constructs an instance of EventNotificationsV1 with passed in options and external configuration.
     *
     * @param {UserOptions} [options] - The parameters to send to the service.
     * @param {string} [options.serviceName] - The name of the service to configure
     * @param {Authenticator} [options.authenticator] - The Authenticator object used to authenticate requests to the service
     * @param {string} [options.serviceUrl] - The URL for the service
     * @returns {EventNotificationsV1}
     */
    EventNotificationsV1.newInstance = function (options) {
        options = options || {};
        if (!options.serviceName) {
            options.serviceName = this.DEFAULT_SERVICE_NAME;
        }
        if (!options.authenticator) {
            options.authenticator = (0, ibm_cloud_sdk_core_1.getAuthenticatorFromEnvironment)(options.serviceName);
        }
        var service = new EventNotificationsV1(options);
        service.configureService(options.serviceName);
        if (options.serviceUrl) {
            service.setServiceUrl(options.serviceUrl);
        }
        return service;
    };
    /*************************
     * sendNotifications
     ************************/
    /**
     * Send a notification.
     *
     * Send a notification.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.subject - The Notifications subject.
     * @param {string} params.severity - The Notifications severity.
     * @param {string} params.id - The Notifications id.
     * @param {string} params.source - The source of Notifications.
     * @param {string} params.enSourceId - The Event Notifications source id.
     * @param {string} params.type - The Notifications type.
     * @param {string} params.time - The Notifications time.
     * @param {JsonObject} [params.data] - The Notifications data for webhook.
     * @param {NotificationDevices} [params.pushTo] - Payload describing a FCM Notifications targets.
     * @param {NotificationFCMBody} [params.messageFcmBody] -
     * @param {JsonObject} [params.messageApnsHeaders] - The attributes for an FCM/APNs notification.
     * @param {NotificationAPNSBody} [params.messageApnsBody] - Payload describing a APNs Notifications body.
     * @param {string} [params.datacontenttype] - The Notifications content type.
     * @param {string} [params.specversion] - The Notifications specversion.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.NotificationResponse>>}
     */
    EventNotificationsV1.prototype.sendNotifications = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = [
            'instanceId',
            'subject',
            'severity',
            'id',
            'source',
            'enSourceId',
            'type',
            'time',
        ];
        var _validParams = [
            'instanceId',
            'subject',
            'severity',
            'id',
            'source',
            'enSourceId',
            'type',
            'time',
            'data',
            'pushTo',
            'messageFcmBody',
            'messageApnsHeaders',
            'messageApnsBody',
            'datacontenttype',
            'specversion',
            'headers',
        ];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var body = {
            'subject': _params.subject,
            'severity': _params.severity,
            'id': _params.id,
            'source': _params.source,
            'en_source_id': _params.enSourceId,
            'type': _params.type,
            'time': _params.time,
            'data': _params.data,
            'push_to': JSON.stringify(_params.pushTo),
            'message_fcm_body': JSON.stringify(_params.messageFcmBody),
            'message_apns_headers': JSON.stringify(_params.messageApnsHeaders),
            'message_apns_body': JSON.stringify(_params.messageApnsBody),
            'datacontenttype': 'application/json',
            'specversion': '1.0',
        };
        var path = {
            'instance_id': _params.instanceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'sendNotifications');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/notifications',
                method: 'POST',
                body: body,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /*************************
     * sources
     ************************/
    /**
     * List all Sources.
     *
     * List all Sources.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {number} [params.limit] - Page limit for paginated results.
     * @param {number} [params.offset] - offset for paginated results.
     * @param {string} [params.search] - Search string for filtering results.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.SourceList>>}
     */
    EventNotificationsV1.prototype.listSources = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId'];
        var _validParams = ['instanceId', 'limit', 'offset', 'search', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'limit': _params.limit,
            'offset': _params.offset,
            'search': _params.search,
        };
        var path = {
            'instance_id': _params.instanceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'listSources');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/sources',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Get a Source.
     *
     * Get a Sources.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Source.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Source>>}
     */
    EventNotificationsV1.prototype.getSource = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'getSource');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/sources/{id}',
                method: 'GET',
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /*************************
     * topics
     ************************/
    /**
     * Create a new Topic.
     *
     * Create a new Topic.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.name - Name of the topic.
     * @param {string} [params.description] - Description of the topic.
     * @param {TopicUpdateSourcesItem[]} [params.sources] - List of sources.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.TopicResponse>>}
     */
    EventNotificationsV1.prototype.createTopic = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'name'];
        var _validParams = ['instanceId', 'name', 'description', 'sources', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var body = {
            'name': _params.name,
            'description': _params.description,
            'sources': _params.sources,
        };
        var path = {
            'instance_id': _params.instanceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'createTopic');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/topics',
                method: 'POST',
                body: body,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * List all Topics.
     *
     * List all Topics.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {number} [params.limit] - Page limit for paginated results.
     * @param {number} [params.offset] - offset for paginated results.
     * @param {string} [params.search] - Search string for filtering results.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.TopicList>>}
     */
    EventNotificationsV1.prototype.listTopics = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId'];
        var _validParams = ['instanceId', 'limit', 'offset', 'search', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'limit': _params.limit,
            'offset': _params.offset,
            'search': _params.search,
        };
        var path = {
            'instance_id': _params.instanceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'listTopics');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/topics',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Get details of a Topic.
     *
     * Get details of a Topic.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Topic.
     * @param {string} [params.include] - Include sub topics.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Topic>>}
     */
    EventNotificationsV1.prototype.getTopic = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'include', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'include': _params.include,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'getTopic');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/topics/{id}',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Update details of a Topic.
     *
     * Update details of a Topic.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Topic.
     * @param {string} [params.name] - Name of the topic.
     * @param {string} [params.description] - Description of the topic.
     * @param {TopicUpdateSourcesItem[]} [params.sources] - List of sources.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Topic>>}
     */
    EventNotificationsV1.prototype.replaceTopic = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'name', 'description', 'sources', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var body = {
            'name': _params.name,
            'description': _params.description,
            'sources': _params.sources,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'replaceTopic');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/topics/{id}',
                method: 'PUT',
                body: body,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Delete a Topic.
     *
     * Delete a Topic.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Topic.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Empty>>}
     */
    EventNotificationsV1.prototype.deleteTopic = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'deleteTopic');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/topics/{id}',
                method: 'DELETE',
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {}, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /*************************
     * destinations
     ************************/
    /**
     * Create a new Destination.
     *
     * Create a new Destination.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.name - The Destintion name.
     * @param {string} params.type - The type of Destination Webhook.
     * @param {string} [params.description] - The Destination description.
     * @param {DestinationConfig} [params.config] - Payload describing a destination configuration.
     * @param {NodeJS.ReadableStream | Buffer} [params.certificate] - Certificate for APNS.
     * @param {string} [params.certificateContentType] - The content type of certificate.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.DestinationResponse>>}
     */
    EventNotificationsV1.prototype.createDestination = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'name', 'type'];
        var _validParams = [
            'instanceId',
            'name',
            'type',
            'description',
            'config',
            'certificate',
            'certificateContentType',
            'headers',
        ];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var formData = {
            'name': _params.name,
            'type': _params.type,
            'description': _params.description,
            'config': _params.config,
            'certificate': {
                data: _params.certificate,
                contentType: _params.certificateContentType,
            },
        };
        var path = {
            'instance_id': _params.instanceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'createDestination');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations',
                method: 'POST',
                path: path,
                formData: formData,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                    'Content-Type': 'multipart/form-data',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * List all Destinations.
     *
     * List all Destinations.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {number} [params.limit] - Page limit for paginated results.
     * @param {number} [params.offset] - offset for paginated results.
     * @param {string} [params.search] - Search string for filtering results.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.DestinationList>>}
     */
    EventNotificationsV1.prototype.listDestinations = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId'];
        var _validParams = ['instanceId', 'limit', 'offset', 'search', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'limit': _params.limit,
            'offset': _params.offset,
            'search': _params.search,
        };
        var path = {
            'instance_id': _params.instanceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'listDestinations');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Get details of a Destination.
     *
     * Get details of a Destination.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Destination>>}
     */
    EventNotificationsV1.prototype.getDestination = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'getDestination');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}',
                method: 'GET',
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Update details of a Destination.
     *
     * Update details of a Destination.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {string} [params.name] - Destination name.
     * @param {string} [params.description] - Destination description.
     * @param {DestinationConfig} [params.config] - Payload describing a destination configuration.
     * @param {NodeJS.ReadableStream | Buffer} [params.certificate] - Certificate for APNS.
     * @param {string} [params.certificateContentType] - The content type of certificate.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Destination>>}
     */
    EventNotificationsV1.prototype.updateDestination = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = [
            'instanceId',
            'id',
            'name',
            'description',
            'config',
            'certificate',
            'certificateContentType',
            'headers',
        ];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var formData = {
            'name': _params.name,
            'description': _params.description,
            'config': _params.config,
            'certificate': {
                data: _params.certificate,
                contentType: _params.certificateContentType,
            },
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'updateDestination');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}',
                method: 'PATCH',
                path: path,
                formData: formData,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                    'Content-Type': 'multipart/form-data',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Delete a Destination.
     *
     * Delete a Destination.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Empty>>}
     */
    EventNotificationsV1.prototype.deleteDestination = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'deleteDestination');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}',
                method: 'DELETE',
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {}, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /*************************
     * destinationsPushDevices
     ************************/
    /**
     * Get list of Destination devices.
     *
     * Get list of Destination devices.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {number} [params.limit] - Page limit for paginated results.
     * @param {number} [params.offset] - offset for paginated results.
     * @param {string} [params.search] - Search string for filtering results.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.DestinationDevicesList>>}
     */
    EventNotificationsV1.prototype.listDestinationDevices = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'limit', 'offset', 'search', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'limit': _params.limit,
            'offset': _params.offset,
            'search': _params.search,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'listDestinationDevices');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}/devices',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Retrieves report of destination devices registered.
     *
     * Retrieves report of destination devices registered.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {number} [params.days] - Number of days report has to be generated from
     * * `Note :` Max value is 90
     * * Min or default value is 1.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.DestinationDevicesReport>>}
     */
    EventNotificationsV1.prototype.getDestinationDevicesReport = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'days', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'days': _params.days,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'getDestinationDevicesReport');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}/devices/report',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /*************************
     * destinationTagsSubscriptions
     ************************/
    /**
     * List all Tag Subscriptions for a device.
     *
     * List all Tag Subscriptions for a device.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {string} params.deviceId - DeviceID of the destination.
     * @param {string} [params.tagName] - TagName of the subscription.
     * @param {number} [params.limit] - Page limit for paginated results.
     * @param {number} [params.offset] - offset for paginated results.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.TagsSubscriptionList>>}
     */
    EventNotificationsV1.prototype.listTagsSubscriptionsDevice = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id', 'deviceId'];
        var _validParams = ['instanceId', 'id', 'deviceId', 'tagName', 'limit', 'offset', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'tag_name': _params.tagName,
            'limit': _params.limit,
            'offset': _params.offset,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
            'device_id': _params.deviceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'listTagsSubscriptionsDevice');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}/tag_subscriptions/devices/{device_id}',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * List all Tag Subscriptions.
     *
     * List all Tag Subscriptions.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {string} [params.deviceId] - DeviceID of the destination tagsubscription.
     * @param {string} [params.userId] - UserID of the destination.
     * @param {string} [params.tagName] - TagName of the subscription.
     * @param {number} [params.limit] - Page limit for paginated results.
     * @param {number} [params.offset] - offset for paginated results.
     * @param {string} [params.search] - Search string for filtering results.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.TagsSubscriptionList>>}
     */
    EventNotificationsV1.prototype.listTagsSubscription = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = [
            'instanceId',
            'id',
            'deviceId',
            'userId',
            'tagName',
            'limit',
            'offset',
            'search',
            'headers',
        ];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'device_id': _params.deviceId,
            'user_id': _params.userId,
            'tag_name': _params.tagName,
            'limit': _params.limit,
            'offset': _params.offset,
            'search': _params.search,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'listTagsSubscription');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}/tag_subscriptions',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Create a new Tag subscription.
     *
     * Create a new Tag subscription.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {string} params.deviceId - Unique identifier of the device.
     * @param {string} params.tagName - The name of the tag its subscribed.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.DestinationTagsSubscriptionResponse>>}
     */
    EventNotificationsV1.prototype.createTagsSubscription = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id', 'deviceId', 'tagName'];
        var _validParams = ['instanceId', 'id', 'deviceId', 'tagName', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var body = {
            'device_id': _params.deviceId,
            'tag_name': _params.tagName,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'createTagsSubscription');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}/tag_subscriptions',
                method: 'POST',
                body: body,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Delete a Tag subcription.
     *
     * Delete a Tag subcription.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Destination.
     * @param {string} [params.deviceId] - DeviceID of the destination tagsubscription.
     * @param {string} [params.tagName] - TagName of the subscription.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Empty>>}
     */
    EventNotificationsV1.prototype.deleteTagsSubscription = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'deviceId', 'tagName', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'device_id': _params.deviceId,
            'tag_name': _params.tagName,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'deleteTagsSubscription');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/destinations/{id}/tag_subscriptions',
                method: 'DELETE',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {}, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /*************************
     * subscriptions
     ************************/
    /**
     * Create a new Subscription.
     *
     * Create a new Subscription.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.name - Subscription name.
     * @param {string} params.destinationId - Destination ID.
     * @param {string} params.topicId - Topic ID.
     * @param {string} [params.description] - Subscription description.
     * @param {SubscriptionCreateAttributes} [params.attributes] -
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Subscription>>}
     */
    EventNotificationsV1.prototype.createSubscription = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'name', 'destinationId', 'topicId'];
        var _validParams = [
            'instanceId',
            'name',
            'destinationId',
            'topicId',
            'description',
            'attributes',
            'headers',
        ];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var body = {
            'name': _params.name,
            'destination_id': _params.destinationId,
            'topic_id': _params.topicId,
            'description': _params.description,
            'attributes': _params.attributes,
        };
        var path = {
            'instance_id': _params.instanceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'createSubscription');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/subscriptions',
                method: 'POST',
                body: body,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * List all Subscriptions.
     *
     * List all Subscriptions.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {number} [params.offset] - offset for paginated results.
     * @param {number} [params.limit] - Page limit for paginated results.
     * @param {string} [params.search] - Search string for filtering results.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.SubscriptionList>>}
     */
    EventNotificationsV1.prototype.listSubscriptions = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId'];
        var _validParams = ['instanceId', 'offset', 'limit', 'search', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var query = {
            'offset': _params.offset,
            'limit': _params.limit,
            'search': _params.search,
        };
        var path = {
            'instance_id': _params.instanceId,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'listSubscriptions');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/subscriptions',
                method: 'GET',
                qs: query,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Get details of a Subscription.
     *
     * Get details of a Subscription.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Subscription.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Subscription>>}
     */
    EventNotificationsV1.prototype.getSubscription = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'getSubscription');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/subscriptions/{id}',
                method: 'GET',
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Delete a Subscription.
     *
     * Delete a Subscription.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Subscription.
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Empty>>}
     */
    EventNotificationsV1.prototype.deleteSubscription = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'deleteSubscription');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/subscriptions/{id}',
                method: 'DELETE',
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {}, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    /**
     * Update details of a Subscription.
     *
     * Update details of a Subscription.
     *
     * @param {Object} params - The parameters to send to the service.
     * @param {string} params.instanceId - Unique identifier for IBM Cloud Event Notifications instance.
     * @param {string} params.id - Unique identifier for Subscription.
     * @param {string} [params.name] - Name of the subscription.
     * @param {string} [params.description] - Description of the subscription.
     * @param {SubscriptionUpdateAttributes} [params.attributes] -
     * @param {OutgoingHttpHeaders} [params.headers] - Custom request headers
     * @returns {Promise<EventNotificationsV1.Response<EventNotificationsV1.Subscription>>}
     */
    EventNotificationsV1.prototype.updateSubscription = function (params) {
        var _params = __assign({}, params);
        var _requiredParams = ['instanceId', 'id'];
        var _validParams = ['instanceId', 'id', 'name', 'description', 'attributes', 'headers'];
        var _validationErrors = (0, ibm_cloud_sdk_core_1.validateParams)(_params, _requiredParams, _validParams);
        if (_validationErrors) {
            return Promise.reject(_validationErrors);
        }
        var body = {
            'name': _params.name,
            'description': _params.description,
            'attributes': _params.attributes,
        };
        var path = {
            'instance_id': _params.instanceId,
            'id': _params.id,
        };
        var sdkHeaders = (0, common_1.getSdkHeaders)(EventNotificationsV1.DEFAULT_SERVICE_NAME, 'v1', 'updateSubscription');
        var parameters = {
            options: {
                url: '/v1/instances/{instance_id}/subscriptions/{id}',
                method: 'PATCH',
                body: body,
                path: path,
            },
            defaultOptions: extend(true, {}, this.baseOptions, {
                headers: extend(true, sdkHeaders, {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                }, _params.headers),
            }),
        };
        return this.createRequest(parameters);
    };
    EventNotificationsV1.DEFAULT_SERVICE_URL = 'https://us-south.event-notifications.cloud.ibm.com/event-notifications';
    EventNotificationsV1.DEFAULT_SERVICE_NAME = 'event_notifications';
    return EventNotificationsV1;
}(ibm_cloud_sdk_core_1.BaseService));
/*************************
 * interfaces
 ************************/
(function (EventNotificationsV1) {
    /** Constants for the `createDestination` operation. */
    var CreateDestinationConstants;
    (function (CreateDestinationConstants) {
        /** The type of Destination Webhook. */
        var Type;
        (function (Type) {
            Type["WEBHOOK"] = "webhook";
            Type["PUSH_ANDROID"] = "push_android";
            Type["PUSH_IOS"] = "push_ios";
        })(Type = CreateDestinationConstants.Type || (CreateDestinationConstants.Type = {}));
    })(CreateDestinationConstants = EventNotificationsV1.CreateDestinationConstants || (EventNotificationsV1.CreateDestinationConstants = {}));
})(EventNotificationsV1 || (EventNotificationsV1 = {}));
module.exports = EventNotificationsV1;
//# sourceMappingURL=v1.js.map